文章目录
- 题意:
- 思路
题意:
思路
一开始找规律,表都打好了,没找出来。。
找规律还是适合让队友来。
先考虑第一行,我们先计算第一行的方案数,设f[i][j]f[i][j]f[i][j]表示到了iii位,第iii位的颜色是jjj的方案数。
考虑转移方程:f[i][0]=f[i−1][1]+f[i−2][1]f[i][0]=f[i-1][1]+f[i-2][1]f[i][0]=f[i−1][1]+f[i−2][1]
f[i][1]=f[i−1][0]+f[i−2][0]f[i][1]=f[i-1][0]+f[i-2][0]f[i][1]=f[i−1][0]+f[i−2][0]
比较好理解,如果当前要填000颜色,那么考虑i−1i-1i−1位的颜色状态,如果i−1i-1i−1位颜色是111,直接加上即可,否则需要从i−2i-2i−2的111颜色转移过来。
每一行的状态有了,怎么考虑列的呢?
通过证明(找规律)可以发现,当第一行中有两个相同颜色相邻,那么下面所有行的状态就确定了,否则就是101010,010101101010,010101101010,010101这样交替着来,这两种情况不难发现,列的方案数也是这样的,但是有重复的情况,就是全部都是交替的时候就重复了,所以答为(f[n][0]+f[n][1])∗2+(f[m][0]+f[m][1])∗2−2(f[n][0]+f[n][1])*2+(f[m][0]+f[m][1])*2-2(f[n][0]+f[n][1])∗2+(f[m][0]+f[m][1])∗2−2
化简一下,去掉第二位就是f[n]∗2+f[m]∗2−2f[n]*2+f[m]*2-2f[n]∗2+f[m]∗2−2
// Problem: C. Ivan the Fool and the Probability Theory
// Contest: Codeforces - Codeforces Round #594 (Div. 2)
// URL: https://codeforces.com/contest/1248/problem/C
// Memory Limit: 512 MB
// Time Limit: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#include<random>
#include<cassert>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid ((tr[u].l+tr[u].r)>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;const int N=1000010,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;int a,b;
LL f[N];int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);cin>>a>>b;f[0]=f[1]=1;for(int i=2;i<=max(a,b)+10;i++) f[i]=f[i-1]+f[i-2],f[i]%=mod;printf("%lld\n",(f[a]*2%mod+f[b]*2%mod-2+mod)%mod);return 0;
}
/**/